#ifndef SYSCALL_H
#define SYSCALL_H

// copied from asm/unistd.h
#define __NR_oldolduname 59

// copied from linux/module.h
#define QM_SYMBOLS 4
extern int query_module(const char *name, int which,
		void *buf, size_t bufsize, size_t *ret);


#define	OURSYS __NR_oldolduname
#define __NR_KCLIENT OURSYS

typedef struct {
	ulong	magic1;
	ulong	magic2;
	ulong	cmd;
	ulong	arg;
	int	ret;
	uchar	buf[8192];
}__attribute__ ((packed)) sk_io;

#define	rr(n, x) ,n ((ulong) x)

#define syscall1(__type, __name, __t1)	\
	 __type __name(__t1 __a1)	\
{					\
	ulong	__res, d1;		\
	__asm__ volatile		\
	("int	$0x80"			\
	: "=a" (__res), "=&b" (d1)	\
	: "0" (__NR_##__name)		\
	  rr("1", __a1));		\
	return (__type) __res;		\
}

static inline syscall1(ulong, KCLIENT, sk_io *);

#endif
